package eu.mhsl.minecraft.WorldMuseum.items.actionItems;

import eu.mhsl.minecraft.WorldMuseum.Main;
import eu.mhsl.minecraft.WorldMuseum.viewableWorld.ViewableWorld;
import net.kyori.adventure.text.Component;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.jetbrains.annotations.NotNull;

import java.util.List;

public class WorldSelector {
    private final ItemStack ITEM = generateWorldSelectorItem();
    private final Inventory INVENTORY = generateWorldSelectorInventory();

    private ItemStack generateWorldSelectorItem() {
        ItemStack item = new ItemStack(Material.GRASS_BLOCK);
        ItemMeta meta = item.getItemMeta();
        meta.displayName(Component.text("Worldselector"));
        item.setItemMeta(meta);
        return item;
    }

    private Inventory generateWorldSelectorInventory() {
        List<ViewableWorld> worlds = Main.instance().getWorlds();

        int itemCount = worlds.size() + 1;
        int inventoryRows = Math.max(itemCount / 9, 1);
        int inventorySize = inventoryRows * 9;
        Inventory inventory = Bukkit.createInventory(null, inventorySize, Component.text("Weltenmuseum"));

        worlds.stream()
                .filter(ViewableWorld::isEnabled)
                .forEach(viewableWorld -> inventory.addItem(viewableWorld.getItem()));

        boolean canExit = Main.instance().getConfig().getBoolean("bungee.enabled");
        if(canExit) inventory.setItem(inventorySize - 1, exitItem());

        return inventory;
    }

    public static ItemStack exitItem() {
        ItemStack stack = ItemStack.of(Material.OAK_DOOR);
        ItemMeta meta = stack.getItemMeta();
        meta.displayName(Component.text("Zurück zum Server"));
        meta.setEnchantmentGlintOverride(true);
        stack.setItemMeta(meta);
        return stack;
    }

    public ItemStack getITEM() {
        return ITEM;
    }

    public void action(@NotNull Player player) {
        player.openInventory(INVENTORY);
    }
}
