package eu.mhsl.minecraft.WorldMuseum.listener;

import eu.mhsl.minecraft.WorldMuseum.Main;
import eu.mhsl.minecraft.WorldMuseum.items.ActionItemManager;
import net.kyori.adventure.util.Ticks;
import org.bukkit.Bukkit;
import org.bukkit.GameMode;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.player.PlayerDropItemEvent;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;

import java.util.Objects;

public class PlayerListener implements Listener {
    @EventHandler
    public void onJoin(PlayerJoinEvent event) {
        event.getPlayer().setGameMode(GameMode.SURVIVAL);
        Main.instance().getWorlds().forEach(world -> {
            if (world.isDefaultWorld()) world.addViewer(event.getPlayer());
        });
        event.getPlayer().addPotionEffect(
            new PotionEffect(PotionEffectType.HASTE, PotionEffect.INFINITE_DURATION, 15, false, false, false)
        );
        ActionItemManager.getInstance().givePlayerItems(event.getPlayer());
    }

    @EventHandler
    public void onBreak(BlockBreakEvent event) {
        event.setDropItems(false);
        Material material = event.getBlock().getType();
        Bukkit.getScheduler().scheduleSyncDelayedTask(
            Main.instance(),
            () -> Objects.requireNonNull(Bukkit.getWorld(event.getBlock().getWorld().getName())).setType(event.getBlock().getLocation(), material), Ticks.TICKS_PER_SECOND * 5
        );
    }

    @EventHandler
    public void onPlace(BlockPlaceEvent event) {
        event.setCancelled(true);
    }

    @EventHandler
    public void onDrop(PlayerDropItemEvent event) {
        event.setCancelled(true);
    }

    @EventHandler
    public void onInteract(PlayerInteractEvent event) {
        ActionItemManager actionItems = ActionItemManager.getInstance();

        event.setCancelled(true);
        Player p = event.getPlayer();
        Action a = event.getAction();
        if ((a != Action.RIGHT_CLICK_AIR) || (event.getItem() == null)) return;
        if (event.getItem().equals(actionItems.getWorldSelector().getITEM())) actionItems.getWorldSelector().action(p);
    }
}
